QGIS Application - Bug report #16925

Field calculator "round” function wrong results if rounding to 8 or more decimals

2017-07-24 11:36 PM - Giovanni Manghi

Status: Closed
Priority: Normal
Assignee:

Category: Field calculator

Affected QGIS version:2.18.11
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?:

Easy fix?:

Resolution:

Copied to github as #:

No

No
fixed/implemented
24824

Description

This is regardless of the datasource and field type, example:

round(40.70298315437546, 8) > -21.47483648

round(40.70298315437546, 7) > 40.7029832

Associated revisions

Revision 4b009f96 - 2017-08-24 06:35 PM - Nyall Dawson

Use std::round instead of gRound

Now that our minimum VS studio version allowed supports std::round,
we should use that in place of Qt's gqRound method.

Because:

- it doesn't truncate to int, resulting in unpredictable
behaviour (refs #16925)

- better to stick to standard c++ methods wherever possible,
since they're likely better supported and optimised by the
compilers

- it's a tiny reduction to the barrier for entry to QGIS
development (I'm sick of pointing out the need to use

gRound during PR reviews!)

History

#1 - 2017-08-23 04:31 PM - Alain Bertholom

In core/qgsexpression.cpp fcnRound:
gRound(...) is called for rounding, an int is returned.

use the math round function instead of gqRound should solve the problem.

The field calculator should return a floating point number in all case...

static QVariant fcnRound( const QVariantList& values, const QgsExpressionContext , QgsExpression parent ){

if (values.length() ==2) {
double number = getDoubleValue( values.at( 0 ), parent );
double scaler = pow( 10.0, getIntValue( values.at( 1), parent) );
/Ireturn QVariant( gRound( number * scaler ) / scaler );
return QVariant( round( number * scaler ) / scaler );

}
if (values.length() == 1)

{
double number = getIntValue( values.at( 0 ), parent );
/Ireturn QVariant( gRound( number ) ).tolnt();
return QVariant( round( number ) );

}

return QVariant();

}

#2 - 2017-08-23 07:21 PM - Nyall Dawson

Nice fix Alain - can you open a pull request on GitHub with this change? That'll make it easy to review.

#3 - 2017-08-23 10:52 PM - Alain Bertholom

On master, 2.18, or both?

#4 - 2017-08-23 11:44 PM - Jiirgen Fischer

Alain Bertholom wrote:

On master, 2.18, or both?

Note that 2.18 is built with VS2010 on Windows, which doesn't have std::round. See commit:8cb578f69, commit:0a1270b9f, commit:ad437bfdff and
commit:4f58f13822

#5 - 2017-08-24 05:27 AM - Nyall Dawson

You can use qgsRound for 2.18, instead of qRound.

#6 - 2018-08-25 03:13 PM - Giovanni Manghi
- Resolution set to fixed/implemented
- Status changed from Open to Closed

Works as expected on master.
